/*===========================================================================
 *
 * File:	Esmbase.CPP
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	February 7, 2003
 *
 * Description
 *
 *=========================================================================*/

	/* Include Files */
#include "esmdefs.h"
#include "dl_str.h"


/*===========================================================================
 *
 * Begin Local Definitions
 *
 *=========================================================================*/
  DEFINE_FILE("EsmBase.cpp")
/*===========================================================================
 *		End of Local Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Magic Effect Array
 *
 *=========================================================================*/
  #define EFF_DUR	MWESM_EFFECTFLAG_HASDUR
  #define EFF_MAG	MWESM_EFFECTFLAG_HASMAG
  #define EFF_ALC	MWESM_EFFECTFLAG_ALCHEMY
  #define EFF_DEF	EFF_DUR | EFF_ALC | EFF_MAG
  #define EFF_SEL	MWESM_EFFECTFLAG_SELFONLY
  #define EFF_NOS	MWESM_EFFECTFLAG_NOSELF
  #define EFF_TRB	MWESM_EFFECTFLAG_TRIB
   
esmeffectdata_t l_Effects[MWESM_EFFECT_MAX+1] = {
	{ _T("Water Breathing"),		EFF_DUR | EFF_ALC,	_T("sEffectWaterBreathing") },
	{ _T("Swift Swim"),			EFF_DEF,		_T("sEffectSwiftSwim") },
	{ _T("Water Walking"),			EFF_DUR | EFF_ALC,	_T("sEffectWaterWalking") },
	{ _T("Shield"),				EFF_DEF,		_T("sEffectShield") },
	{ _T("Fire Shield"),			EFF_DEF,		_T("sEffectFireShield") },
	{ _T("Lightning Shield"),		EFF_DEF,		_T("sEffectLightningShield") },
	{ _T("Frost Shield"),			EFF_DEF,		_T("sEffectFrostShield") },
	{ _T("Burden"),				EFF_DEF,		_T("sEffectBurden") },
	{ _T("Feather"),			EFF_DEF,		_T("sEffectFeather") },
	{ _T("Jump"),				EFF_DEF,		_T("sEffectJump") },
	{ _T("Levitate"),			EFF_DEF,		_T("sEffectLevitate") },
	{ _T("SlowFall"),			EFF_DEF,		_T("sEffectSlowFall") },
	{ _T("Lock"),				EFF_DEF | EFF_NOS,	_T("sEffectLock") },
	{ _T("Open"),				EFF_DEF | EFF_NOS,	_T("sEffectOpen") },
	{ _T("Fire Damage"),			EFF_DEF,		_T("sEffectFireDamage") },
	{ _T("Shock Damage"),			EFF_DEF,		_T("sEffectShockDamage") },
	{ _T("Frost Damage"),			EFF_DEF,		_T("sEffectFrostDamage") },
	{ _T("Drain Attribute"),		EFF_DEF,		_T("sEffectDrainAttribute") },
	{ _T("Drain Health"),			EFF_DEF,		_T("sEffectDrainHealth") },
	{ _T("Drain Magicka"),			EFF_DEF,		_T("sEffectDrainSpellpoints") },
	{ _T("Drain Fatigue"),			EFF_DEF,		_T("sEffectDrainFatigue") },
	{ _T("Drain Skill"),			EFF_DEF,		_T("sEffectDrainSkill") },
	{ _T("Damage Attribute"),		EFF_DEF,		_T("sEffectDamageAttribute") },
	{ _T("Damage Health"),			EFF_DEF,		_T("sEffectDamageHealth") },
	{ _T("Damage Magicka"),			EFF_DEF,		_T("sEffectDamageMagicka") },
	{ _T("Damage Fatigue"),			EFF_DEF,		_T("sEffectDamageFatigue") },
	{ _T("Damage Skill"),			EFF_DEF,		_T("sEffectDamageSkill") },
	{ _T("Poison"),				EFF_DEF,		_T("sEffectPoison") },
	{ _T("Weakness to Fire"),		EFF_DEF,		_T("sEffectWeaknessToFire") },
	{ _T("Weakness to Frost"),		EFF_DEF,		_T("sEffectWeaknessToFrost") },
	{ _T("Weakness to Shock"),		EFF_DEF,		_T("sEffectWeaknessToShock") },
	{ _T("Weakness to Magicka"),		EFF_DEF,		_T("sEffectWeaknessToMagicka") },
	{ _T("Weakness to Common Disease"),	EFF_DEF,		_T("sEffectWeaknessToCommonDisease") },
	{ _T("Weakness to Blight Disease"),	EFF_DEF,		_T("sEffectWeaknessToBlightDisease") },
	{ _T("Weakness to Corprus Disease"),	EFF_DEF,		_T("sEffectWeaknessToCorprusDisease") },
	{ _T("Weakness to Poison"),		EFF_DEF,		_T("sEffectWeaknessToPoison") },
	{ _T("Weakness to Normal Weapons"),	EFF_DEF,		_T("sEffectWeaknessToNormalWeapons") },
	{ _T("Disintegrate Weapon"),		EFF_DEF,		_T("sEffectDisintegrateWeapon") },
	{ _T("Disintegrate Armor"),		EFF_DEF,		_T("sEffectDisintegrateArmor") },
	{ _T("Invisibility"),			EFF_MAG | EFF_ALC,	_T("sEffectInvisibility") },
	{ _T("Chameleon"),			EFF_DEF,		_T("sEffectChameleon") },
	{ _T("Light"),				EFF_DEF,		_T("sEffectLight") },
	{ _T("Sanctuary"),			EFF_DEF,		_T("sEffectSanctuary") },
	{ _T("Night Eye"),			EFF_DEF,		_T("sEffectNightEye") },
	{ _T("Charm"),				EFF_DUR | EFF_MAG | EFF_NOS, _T("sEffectCharm") },
	{ _T("Paralyze"),			EFF_DUR | EFF_ALC,	_T("sEffectParalyze") },
	{ _T("Silence"),			EFF_DUR | EFF_ALC,	_T("sEffectSilence") },
	{ _T("Blind"),				EFF_DUR | EFF_ALC | EFF_MAG, _T("sEffectBlind") },
	{ _T("Sound"),				EFF_DEF,		_T("sEffectSound") },
	{ _T("Calm Humanoid"),			EFF_DUR | EFF_MAG | EFF_NOS, _T("sEffectCalmHumanoid") },
	{ _T("Calm Creature"),			EFF_DUR | EFF_MAG | EFF_NOS, _T("sEffectCalmCreature")  },
	{ _T("Frenzy Humanoid"),		EFF_DUR | EFF_MAG | EFF_NOS, _T("sEffectFrenzyHumanoid")  },
	{ _T("Frenzy Creature"),		EFF_DUR | EFF_MAG | EFF_NOS, _T("sEffectFrenzyCreature")  },
	{ _T("Demoralize Humanoid"),		EFF_DUR | EFF_MAG | EFF_NOS, _T("sEffectDemoralizeHumanoid")  },
	{ _T("Demoralize Creature"),		EFF_DUR | EFF_MAG | EFF_NOS, _T("sEffectDemoralizeCreature")  },
	{ _T("Rally Humanoid"),			EFF_DUR | EFF_MAG | EFF_NOS, _T("sEffectRallyHumanoid")  },
	{ _T("Rally Creature"),			EFF_DUR | EFF_MAG | EFF_NOS, _T("sEffectRallyCreature")  },
	{ _T("Dispel"),				EFF_MAG | EFF_ALC,	_T("sEffectDispel") },
	{ _T("Soultrap"),			EFF_DUR | EFF_NOS,	_T("sEffectSoultrap") },
	{ _T("Telekinesis"),			EFF_DEF | EFF_SEL,	_T("sEffectTelekinesis") },
	{ _T("Mark"),				EFF_ALC | EFF_SEL,	_T("sEffectMark") },
	{ _T("Recall"),				EFF_ALC | EFF_SEL,	_T("sEffectRecall") },
	{ _T("Divine Intervention"),		EFF_ALC | EFF_SEL,	_T("sEffectDivineIntervention") },
	{ _T("Almsivi Intervention"),		EFF_ALC | EFF_SEL,	_T("sEffectAlmsiviIntervention") },
	{ _T("Detect Animal"),			EFF_DEF | EFF_SEL,	_T("sEffectDetectAnimal") },
	{ _T("Detect Enchantment"),		EFF_DEF | EFF_SEL,	_T("sEffectDetectEnchantment") },
	{ _T("Detect Key"),			EFF_DEF | EFF_SEL,	_T("sEffectDetectKey") },
	{ _T("Spell Absorption"),		EFF_DEF,		_T("sEffectSpellAbsorption") },
	{ _T("Reflect"),			EFF_DEF,		_T("sEffectReflect") },
	{ _T("Cure Common Disease"),		EFF_ALC,		_T("sEffectCureCommonDisease") },
	{ _T("Cure Blight Disease"),		EFF_ALC,		_T("sEffectCureBlightDisease") },
	{ _T("Cure Corprus Disease"),		EFF_ALC,		_T("sEffectCureCorprusDisease") },
	{ _T("Cure Poison"),			EFF_ALC,		_T("sEffectCurePoison") },
	{ _T("Cure Paralyzation"),		EFF_ALC,		_T("sEffectCureParalyzation") },
	{ _T("Restore Attribute"),		EFF_DEF,		_T("sEffectRestoreAttribute") },
	{ _T("Restore Health"),			EFF_DEF,		_T("sEffectRestoreHealth") },
	{ _T("Restore Magicka"),		EFF_DEF,		_T("sEffectRestoreSpellPoints") },
	{ _T("Restore Fatigue"),		EFF_DEF,		_T("sEffectRestoreFatigue") },
	{ _T("Restore Skill"),			EFF_DEF,		_T("sEffectRestoreSkill") },
	{ _T("Fortify Attribute"),		EFF_DEF,		_T("sEffectFortifyAttribute") },
	{ _T("Fortify Health"),			EFF_DEF,		_T("sEffectFortifyHealth") },
	{ _T("Fortify Magicka"),		EFF_DEF,		_T("sEffectFortifySpellpoints") },
	{ _T("Fortify Fatigue"),		EFF_DEF,		_T("sEffectFortifyFatigue") },
	{ _T("Fortify Skill"),			EFF_DEF,		_T("sEffectFortifySkill") },
	{ _T("Fortify Maximum Magicka"),	EFF_DEF,		_T("sEffectFortifyMagickaMultiplier") },
	{ _T("Absorb Attribute"),		EFF_DEF,		_T("sEffectAbsorbAttribute") },
	{ _T("Absorb Health"),			EFF_DEF,		_T("sEffectAbsorbHealth") },
	{ _T("Absorb Magicka"),			EFF_DEF,		_T("sEffectAbsorbSpellPoints") },
	{ _T("Absorb Fatigue"),			EFF_DEF,		_T("sEffectAbsorbFatigue") },
	{ _T("Absorb Skill"),			EFF_DEF,		_T("sEffectAbsorbSkill") },
	{ _T("Resist Fire"),			EFF_DEF,		_T("sEffectResistFire") },
	{ _T("Resist Frost"),			EFF_DEF,		_T("sEffectResistFrost") },
	{ _T("Resist Shock"),			EFF_DEF,		_T("sEffectResistShock") },
	{ _T("Resist Magicka"),			EFF_DEF,		_T("sEffectResistMagicka") },
	{ _T("Resist Common Disease"),		EFF_DEF,		_T("sEffectResistCommonDisease") },
	{ _T("Resist Blight Disease"),		EFF_DEF,		_T("sEffectResistBlightDisease") },
	{ _T("Resist Corprus Disease"),		EFF_DEF,		_T("sEffectResistCorprusDisease") },
	{ _T("Resist Poison"),			EFF_DEF,		_T("sEffectResistPoison") },
	{ _T("Resist Normal Weapons"),		EFF_DEF,		_T("sEffectResistNormalWeapons") },
	{ _T("Resist Paralysis"),		EFF_DEF,		_T("sEffectResistParalysis") },
	{ _T("Remove Curse"),			EFF_DEF,		_T("sEffectRemoveCurse") },
	{ _T("Turn Undead"),			EFF_DUR | EFF_NOS | EFF_SEL, _T("sEffectTurnUndead") },
	{ _T("Summon Scamp"),			EFF_DUR | EFF_ALC | EFF_SEL, _T("sEffectSummonScamp")  },
	{ _T("Summon Clannfear"),		EFF_DUR | EFF_ALC | EFF_SEL, _T("sEffectSummonClannfear")  },
	{ _T("Summon Daedroth"),		EFF_DUR | EFF_ALC | EFF_SEL, _T("sEffectSummonDaedroth")  },
	{ _T("Summon Dremora"),			EFF_DUR | EFF_ALC | EFF_SEL, _T("sEffectSummonDremora")  },
	{ _T("Summon Ancestral Ghost"),		EFF_DUR | EFF_ALC | EFF_SEL, _T("sEffectSummonAncestralGhost")  },
	{ _T("Summon Skeletal Minion"),		EFF_DUR | EFF_ALC | EFF_SEL, _T("sEffectSummonSkeletalMinion")  },
	{ _T("Summon Bonewalker"),		EFF_DUR | EFF_ALC | EFF_SEL, _T("sEffectSummonLeastBonewalker")  },
	{ _T("Summon Greater Bonewalker"),	EFF_DUR | EFF_ALC | EFF_SEL, _T("sEffectSummonGreaterBonewalker")  },
	{ _T("Summon Bonelord"),		EFF_DUR | EFF_ALC | EFF_SEL, _T("sEffectSummonBonelord")  },
	{ _T("Summon Winged Twilight"),		EFF_DUR | EFF_ALC | EFF_SEL, _T("sEffectSummonWingedTwilight")  },
	{ _T("Summon Hunger"),			EFF_DUR | EFF_ALC | EFF_SEL, _T("sEffectSummonHunger")  },
	{ _T("Summon Golden Saint"),		EFF_DUR | EFF_ALC | EFF_SEL, _T("sEffectSummonGoldensaint")  },
	{ _T("Summon Flame Atronach"),		EFF_DUR | EFF_ALC | EFF_SEL, _T("sEffectSummonFlameAtronach")  },
	{ _T("Summon Frost Atronach"),		EFF_DUR | EFF_ALC | EFF_SEL, _T("sEffectSummonFrostAtronach")  },
	{ _T("Summon Storm Atronach"),		EFF_DUR | EFF_ALC | EFF_SEL, _T("sEffectSummonStormAtronach")  },
	{ _T("Fortify Attack"),			EFF_DEF,			_T("sEffectFortifyAttackBonus") },
	{ _T("Command Creature"),		EFF_DUR | EFF_MAG | EFF_NOS, _T("sEffectCommandCreatures") },
	{ _T("Command Humanoid"),		EFF_DUR | EFF_MAG | EFF_NOS, _T("sEffectCommandHumanoids")  },
	{ _T("Bound Dagger"),			EFF_DUR | EFF_ALC | EFF_SEL, _T("sEffectBoundDagger")  },
	{ _T("Bound Longsword"),		EFF_DUR | EFF_ALC | EFF_SEL, _T("sEffectBoundLongsword")  },
	{ _T("Bound Mace"),			EFF_DUR | EFF_ALC | EFF_SEL, _T("sEffectBoundMace")  },
	{ _T("Bound Battle Axe"),		EFF_DUR | EFF_ALC | EFF_SEL, _T("sEffectBoundBattleAxe")  },
	{ _T("Bound Spear"),			EFF_DUR | EFF_ALC | EFF_SEL, _T("sEffectBoundSpear")  },
	{ _T("Bound Longbow"),			EFF_DUR | EFF_ALC | EFF_SEL, _T("sEffectBoundLongbow")  },
	{ _T("EXTRA SPELL"),			0,				_T("sEffectExtraSpell") },
	{ _T("Bound Cuirass"),			EFF_DUR | EFF_ALC | EFF_SEL, _T("sEffectBoundCuirass")  },
	{ _T("Bound Helm"),			EFF_DUR | EFF_ALC | EFF_SEL, _T("sEffectBoundHelm")  },
	{ _T("Bound Boots"),			EFF_DUR | EFF_ALC | EFF_SEL, _T("sEffectBoundBoots")  },
	{ _T("Bound Shield"),			EFF_DUR | EFF_ALC | EFF_SEL, _T("sEffectBoundShield")  },
	{ _T("Bound Gloves"),			EFF_DUR | EFF_ALC | EFF_SEL, _T("sEffectBoundGloves")  },
	{ _T("Corprus"),			EFF_DUR | EFF_ALC | EFF_SEL, _T("sEffectCorpus")  },
	{ _T("Vampirism"),			EFF_ALC | EFF_SEL,		_T("sEffectVampirism") },
	{ _T("Summon Centurion Sphere"),	EFF_DUR | EFF_ALC | EFF_SEL, _T("sEffectSummonCenturionSphere") },
	{ _T("Sun Damage"),			EFF_DEF | EFF_SEL,		_T("sEffectSunDamage") },
	{ _T("Stunted Magicka"),		EFF_DUR | EFF_ALC | EFF_SEL,	_T("sEffectStuntedMagicka") },
	{ _T("sEffectSummonFabricant"),		EFF_DUR | EFF_TRB | EFF_ALC | EFF_SEL, _T("sEffectStuntedFabricant")  }
 };
/*===========================================================================
 *		End of Magic Effect Array
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Skill Array
 *
 *=========================================================================*/
esmskilldata_t l_Skills[] = {
	{ _T("Block"),		_T("Successful Block"), NULL, NULL, NULL },
	{ _T("Armorer"),	_T("Successful Repair"), NULL, NULL, NULL },
	{ _T("Medium Armor"),	_T("Hit by Opponent"), NULL, NULL, NULL },
	{ _T("Heavy Armor"),	_T("Hit by Opponent"), NULL, NULL, NULL },
	{ _T("Blunt Weapon"),	_T("Hit by Opponent"), NULL, NULL, NULL },
	{ _T("Long Blade"),	_T("Successful Attack"), NULL, NULL, NULL },
	{ _T("Axe"),		_T("Successful Attack"), NULL, NULL, NULL },
	{ _T("Spear"),		_T("Successful Attack"), NULL, NULL, NULL },
	{ _T("Athletics"),	_T("Second of Running"), _T("Second of Swimming"), NULL, NULL },
	{ _T("Enchant"),	_T("Recharge Item"), _T("Use Magic Item"), _T("Create Magic Item"), _T("Cast When Strikes") },
	{ _T("Destruction"),	_T("Successful Cast"), NULL, NULL, NULL },
	{ _T("Alteration"),	_T("Successful Cast"), NULL, NULL, NULL },
	{ _T("Illusion"),	_T("Successful Cast"), NULL, NULL, NULL },
	{ _T("Conjuration"),	_T("Successful Cast"), NULL, NULL, NULL },
	{ _T("Mysticism"),	_T("Successful Cast"), NULL, NULL, NULL },
	{ _T("Restoration"),	_T("Successful Cast"), NULL, NULL, NULL },
	{ _T("Alchemy"),	_T("Potion Use"), _T("Ingrediant Use"), NULL, NULL },
	{ _T("Unarmored"),	_T("Hit by Opponent"), NULL, NULL, NULL },
	{ _T("Security"),	_T("Defeat Trap"), _T("Pick Lock"), NULL, NULL },
	{ _T("Sneak"),		_T("Avoid Notice"), _T("Successful Pick Pocket"), NULL, NULL },
	{ _T("Acrobatics"),	_T("Jump"), _T("Fall"), NULL, NULL },
	{ _T("Light Armor"),	_T("Hit by Opponent"), NULL, NULL, NULL },
	{ _T("Short Blade"),	_T("Hit by Opponent"), NULL, NULL, NULL },
	{ _T("Marksman"),	_T("Hit by Opponent"), NULL, NULL, NULL },
	{ _T("Mercantile"),	_T("Successful Bargain"), _T("Successful Bribe"), NULL, NULL },
	{ _T("Speechcraft"),	_T("Successful Persuasion"), _T("Failed Persuasion"), NULL, NULL },
	{ _T("Hand-to-hand"), 	_T("Hit by Opponent"), NULL, NULL, NULL }
 };
/*===========================================================================
 *		End of Skill Array
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Attribute Array
 *
 *=========================================================================*/
const TCHAR* l_Attributes[] = {
	_T("Strength"),
	_T("Intelligence"),
	_T("Willpower"),
	_T("Agility"),
	_T("Speed"),
	_T("Endurance"),
	_T("Personality"),
	_T("Luck"),
 };
/*===========================================================================
 *		End of Attribute Array
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Spell Schools Array
 *
 *=========================================================================*/
const TCHAR* l_SpellSchools[] = {
	_T("Alteration"),
	_T("Conjuration"),
	_T("Destruction"),
	_T("Illusion"),
	_T("Mysticism"),
	_T("Restoration")
  };

/*===========================================================================
 *		End of Spell Schools Array
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Animation Groups Array
 *
 *=========================================================================*/
esmanimdata_t l_AnimData[] = {
	{ "BowAndArrow",		0x83 },
	{ "Crossbow",			0x82 },
	{ "Death1",			0x18 },
	{ "Death2",			0x19 },
	{ "Death3",			0x1A },
	{ "Death4",			0x1B },
	{ "Death5",			0x1C },
	{ "DeathKnockDown",		0x1D },
	{ "DeathKnockOut",		0x1E },
	{ "HandToHand",			0x81 },
	{ "Hit1",			0x13 },
	{ "Hit2",			0x14 },
	{ "Hit3",			0x16 },
	{ "Hit5",			0x17 },
	{ "idle",			0x00 },
	{ "idle1h",			0x0A },
	{ "idle2",			0x01 },
	{ "idle2c",			0x0B },
	{ "idle2w",			0x0C },
	{ "idle3",			0x02 },
	{ "idle4",			0x03 },
	{ "idle5",			0x04 },
	{ "idle6",			0x05 },
	{ "idle7",			0x06 },
	{ "idle8",			0x07 },
	{ "idle9",			0x08 },
	{ "idleCrossBow",		0x0F },
	{ "idlehh",			0x09 },
	{ "idleSneak",			0x10 },
	{ "idleSpell",			0x0E },
	{ "idleStorm",			0x11 },
	{ "idleSwim",			0x0D },
	{ "InventoryHandToHand",	0x8A },
	{ "InventoryWeaponOneHand",	0x8B },
	{ "InventoryWeaponTwoHand",	0x8C },
	{ "InventoryWeaponTwoWide",	0x8D },
	{ "Jump",			0x3E },
	{ "Jump1h",			0x5C },
	{ "Jump2c",			0x6B },
	{ "Jump2w",			0x7A },
	{ "Jumphh",			0x4D },
	{ "KnockDown",			0x1F },
	{ "KnockOut",			0x20 },
	{ "PickProbe",			0x89 },
	{ "RunBack",			0x37 },
	{ "RunBack1h",			0x55 },
	{ "RunBack2c",			0x64 },
	{ "RunBack2w",			0x73 },
	{ "RunBackhh",			0x46 },
	{ "RunForward",			0x36 },
	{ "RunForward1h",		0x54 },
	{ "RunForward2c",		0x63 },
	{ "RunForward2w",		0x72 },
	{ "RunForwardhh",		0x45 },
	{ "RunLeft",			0x38 },
	{ "RunLeft1h",			0x56 },
	{ "RunLeft2c",			0x65 },
	{ "RunLeft2w",			0x74 },
	{ "RunLefthh",			0x47 },
	{ "RunRight1h",			0x57 },
	{ "RunRight2c",			0x66 },
	{ "RunRight2w",			0x75 },
	{ "RunRighthh",			0x48 },
	{ "Shield",			0x88 },
	{ "SneakBack",			0x3B },
	{ "SneakBack1h",		0x59 },
	{ "SneakBack2c",		0x68 },
	{ "SneakBack2w",		0x77 },
	{ "SneakBackhh",		0x4A },
	{ "SneakForward",		0x3A },
	{ "SneakForward1h",		0x58 },
	{ "SneakForward2c",		0x67 },
	{ "SneakForward2w",		0x76 },
	{ "SneakForwardhh",		0x49 },
	{ "SneakLeft",			0x3C },
	{ "SneakLeft1h",		0x5A },
	{ "SneakLeft2c",		0x69 },
	{ "SneakLeft2w",		0x78 },
	{ "SneakLefthh",		0x4B },
	{ "SneakRight",			0x3D },
	{ "SneakRight1h",		0x5B },
	{ "SneakRight2c",		0x6A },
	{ "SneakRight2w",		0x79 },
	{ "SneakRighthh",		0x4C },
	{ "SpellCast",			0x7B },
	{ "SpellTurnRight",		0x7D },
	{ "SpellTurnLeft",		0x7C },
	{ "SwimDeath",			0x21 },
	{ "SwimDeathKnockDown",		0x22 },
	{ "SwimDeathKnockOut",		0x23 },
	{ "SwimKnockDown",		0x25 },
	{ "SwimKnockOut",		0x24 },
	{ "SwimRunBack",		0x2B },
	{ "SwimRunForward",		0x2A },
	{ "SwimRunLeft",		0x2C },
	{ "SwimRunRight",		0x2D },
	{ "SwimTurnLeft",		0x2E },
	{ "SwimTurnRight",		0x2F },
	{ "SwimWalkBack",		0x27 },
	{ "SwimWalkForward",		0x26 },
	{ "SwimWalkLeft",		0x28 },
	{ "SwimWalkRight",		0x29 },
	{ "ThrowWeapon",		0x84 },
	{ "Torch",			0x12 },
	{ "TurnLeft",			0x34 },
	{ "TurnLeft1h",			0x52 },
	{ "TurnLeft2c",			0x61 },
	{ "TurnLeft2w",			0x70 },
	{ "TurnLefthh",			0x43 },
	{ "TurnRight",			0x35 },
	{ "TurnRight1h",		0x53 },
	{ "TurnRight2c",		0x62 },
	{ "TurnRight2w",		0x71 },
	{ "TurnRighthh",		0x44 },
	{ "WalkBack",			0x31 },
	{ "WalkBack1h",			0x4F },
	{ "WalkBack2c",			0x5E },
	{ "WalkBack2w",			0x6D },
	{ "WalkBackhh",			0x40 },
	{ "WalkForward",		0x30 },
	{ "WalkForward1h",		0x4E },
	{ "WalkForward2c",		0x5D },
	{ "WalkForward2w",		0x6C },
	{ "WalkForwardhh",		0x3F },
	{ "WalkLeft",			0x32 },
	{ "WalkLeft1h",			0x50 },
	{ "WalkLeft2c",			0x5F },
	{ "WalkLeft2w",			0x6E },
	{ "WalkLefthh",			0x41 },
	{ "WalkRight",			0x33 },
	{ "WalkRight1h",		0x51 },
	{ "WalkRight2c",		0x60 },
	{ "WalkRight2w",		0x6F },
	{ "WalkRighthh",		0x42 },
	{ "WeaponOneHand",		0x85 },
	{ "WeaponTwoHand",		0x86 },
	{ "WeaponTwoWide",		0x87 },
	{ NULL,				0x00 } /* Must be last element */
  };
/*===========================================================================
 *		End of Animation Groups Array
 *=========================================================================*/


/*===========================================================================
 *
 * Function - const TCHAR* GetESMSkill (SkillID);
 *
 * Converts the input skill ID to a string.  Always returns a valid string.
 *
 *=========================================================================*/
const TCHAR* GetESMSkill (const int SkillID) {
  if (SkillID < 0 || SkillID >= MWESM_MAX_SKILLS) return _T("");
  return l_Skills[SkillID].Name;
 }


int GetESMSkill (const TCHAR* pString) {
  int Index;

  for (Index = 0; Index < MWESM_MAX_SKILLS; Index++) {
    if (TSTRICMP(l_Skills[Index].Name, pString) == 0) return (Index);
   }

  return (0);
 }
/*===========================================================================
 *		End of Function TCHAR* GetESMSkill()
 *=========================================================================*/


/*===========================================================================
 *
 * Function - const TCHAR* GetESMSkillAction (SkillID, Action);
 *
 *=========================================================================*/
const TCHAR* GetESMSkillAction (const int SkillID, const int Action) {
  if (SkillID < 0 || SkillID >= MWESM_MAX_SKILLS) return (NULL);

  if (Action == 0) return l_Skills[SkillID].Action1;
  if (Action == 1) return l_Skills[SkillID].Action2;
  if (Action == 2) return l_Skills[SkillID].Action3;
  if (Action == 3) return l_Skills[SkillID].Action4;
  return (NULL);
 }
/*===========================================================================
 *		End of Function TCHAR* GetESMSkillAction()
 *=========================================================================*/


/*===========================================================================
 *
 * Function - const TCHAR* GetESMEffect (EffectID);
 *
 *  Converts the input effect ID to a string.  Always returns a valid string.
 *
 *=========================================================================*/
const TCHAR* GetESMEffect (const int EffectID) {
  if (EffectID < 0 || EffectID >= MWESM_MAX_EFFECTS) return _T("");
  return l_Effects[EffectID].Name;
 }
/*===========================================================================
 *		End of Function TCHAR* GetESMEffect()
 *=========================================================================*/


/*===========================================================================
 *
 * Function - const esmeffectdata_t* GetESMEffectData (EffectID);
 *
 *=========================================================================*/
const esmeffectdata_t* GetESMEffectData (const int EffectID) {
  if (EffectID < 0 || EffectID >= MWESM_MAX_EFFECTS) return (NULL);
  return &(l_Effects[EffectID]);
 }
/*===========================================================================
 *		End of Function esmeffectdata_t GetESMEffectData()
 *=========================================================================*/


/*===========================================================================
 *
 * Function - const int  FindESMEffectID (pEffectID);
 *
 * Returns the Effect index for the given effect ID string, or -1 if the
 * ID string is invalid.
 *
 *=========================================================================*/
int FindESMEffectID (const TCHAR* pEffectID) {
  int Index;

  for (Index = 0; Index < MWESM_MAX_EFFECTS; Index++) {
    if (l_Effects[Index].IsID(pEffectID)) return (Index);
   }

  return (-1);
 }

int GetESMEffectID (const TCHAR* pString) {
  int Index;

  for (Index = 0; Index < MWESM_MAX_EFFECTS; Index++) {
    if (TSTRICMP(l_Effects[Index].ID,   pString) == 0) return (Index);
    if (TSTRICMP(l_Effects[Index].Name, pString) == 0) return (Index);
   }

  return (-1);
 }
/*===========================================================================
 *		End of Function int  FindESMEffectID()
 *=========================================================================*/


/*===========================================================================
 *
 * Function - const TCHAR* GetESMAttribute (AttributeID);
 *
 * Converts the input attribute ID to a string.  Always returns a valid string.
 *
 *=========================================================================*/
const TCHAR* GetESMAttribute (const int AttributeID) {
  if (AttributeID < 0 || AttributeID >= MWESM_MAX_ATTRIBUTES) return _T("");
  return l_Attributes[AttributeID];
 }


int GetESMAttribute (const TCHAR* pString) {
  int Index;

  for (Index = 0; Index < MWESM_MAX_ATTRIBUTES; Index++) {
    if (TSTRICMP(l_Attributes[Index], pString) == 0) return (Index);
   }

  return (0);
 }
/*===========================================================================
 *		End of Function TCHAR* GetESMAttribute()
 *=========================================================================*/


/*===========================================================================
 *
 * Function - const TCHAR* GetESMSpellSchool (SpellSchool);
 *
 *=========================================================================*/
const TCHAR* GetESMSpellSchool (const int SpellSchool) {
  if (SpellSchool < MWESM_SCHOOL_MIN || SpellSchool > MWESM_SCHOOL_MAX) return _T("");
  return l_SpellSchools[SpellSchool];
 }
/*===========================================================================
 *		End of Function TCHAR* GetESMSpellSchool()
 *=========================================================================*/


/*===========================================================================
 *
 * Function - const TCHAR* GetESMClassSpec (Spec);
 *
 *=========================================================================*/
const TCHAR* GetESMClassSpec (const int Spec) {
  switch (Spec) {
    case MWESM_CLASSSPEC_COMBAT:	return _T("Combat");
    case MWESM_CLASSSPEC_MAGIC:		return _T("Magic");
    case MWESM_CLASSSPEC_STEALTH:	return _T("Stealth");
    default: return _T("Unknown");
   }
 }
/*===========================================================================
 *		End of Function TCHAR* GetESMClassSpec()
 *=========================================================================*/


/*===========================================================================
 *
 * Function - short GetESMAnimGroupID (pGroup);
 *
 * Attempts to find and return the given animation group ID. Returns -1 if
 * the group is not found.
 *
 *=========================================================================*/
short GetESMAnimGroupID (const TCHAR* pGroup) {
  int Index;

  for (Index = 0; l_AnimData[Index].pName != NULL; Index++) {
    if (l_AnimData[Index].IsName(pGroup)) return (l_AnimData[Index].ID);
   }

	/* None found */
  return (-1);
 }
/*===========================================================================
 *		End of Function GetESMAnimGroupID()
 *=========================================================================*/


/*===========================================================================
 *
 * Function - bool IsESMAttributeEffect (EffectID);
 *
 *=========================================================================*/
bool IsESMAttributeEffect (const int EffectID) {
  switch (EffectID) {
    case MWESM_EFFECT_DRAINATTR:
    case MWESM_EFFECT_ABSORBATTR:
    case MWESM_EFFECT_FORTATTR:
    case MWESM_EFFECT_RESTOREATTR:
    case MWESM_EFFECT_DAMAGEATTR:
	return (true);
    default:
	return (false);
   }
 }
/*===========================================================================
 *		End of Function IsESMAttributeEffect()
 *=========================================================================*/


/*===========================================================================
 *
 * Function - bool IsESMSkillEffect (EffectID);
 *
 *=========================================================================*/
bool IsESMSkillEffect (const int EffectID) {

  switch (EffectID) {
    case MWESM_EFFECT_DRAINSKILL:
    case MWESM_EFFECT_ABSORBSKILL:
    case MWESM_EFFECT_FORTSKILL:
    case MWESM_EFFECT_RESTORESKILL:
    case MWESM_EFFECT_DAMAGESKILL:
	return (true);
    default:
	return (false);
   }
 }
/*===========================================================================
 *		End of Function IsESMSkillEffect()
 *=========================================================================*/


/*===========================================================================
 *
 * Function - bool IsESMRecordCarryable (pType);
 *
 * Returns true if the given record type represents an object that can be
 * carried (Armor, weapons, etc...).
 *
 *=========================================================================*/
bool IsESMRecordCarryable (const TCHAR* pType) {
  static long s_ValidTypes[] = { *(long *)MWESM_REC_ALCH, *(long *)MWESM_REC_APPA, *(long *)MWESM_REC_ARMO, 
	*(long *)MWESM_REC_BOOK, *(long *)MWESM_REC_CLOT, *(long *)MWESM_REC_INGR, *(long *)MWESM_REC_LEVI, 
	*(long *)MWESM_REC_LIGH, *(long *)MWESM_REC_LOCK, *(long *)MWESM_REC_MISC, *(long *)MWESM_REC_REPA, 
	*(long *)MWESM_REC_PROB, *(long *)MWESM_REC_WEAP, 0 };
  int  Index;
  long TypeLong = *(long *) pType;

  for (Index = 0; s_ValidTypes[Index] != 0; Index++) {
    if (TypeLong == s_ValidTypes[Index]) return (true);
   }

	/* Matching object not found */
  return (false);
 } 
/*===========================================================================
 *		End of Function IsESMRecordCarryable()
 *=========================================================================*/


/*===========================================================================
 *
 * Function - bool IsESMRecordModel (const TCHAR* pType);
 *
 * Returns true if the given record is a type that has a model and can be
 * placed in the world.
 *
 *=========================================================================*/
bool IsESMRecordModel (const TCHAR* pType) {
  static long s_ValidTypes[] = { *(long *)MWESM_REC_STAT, *(long *)MWESM_REC_ACTI, *(long *)MWESM_REC_DOOR,
		*(long *)MWESM_REC_CREA, *(long *)MWESM_REC_LEVC, *(long *)MWESM_REC_LEVI, *(long *)MWESM_REC_NPC_,
		*(long *)MWESM_REC_CONT, 0 };
  int  Index;
  long TypeLong = *(long *) pType;

  	/* All carryable records are included */
  if (IsESMRecordCarryable(pType)) return (true);

  for (Index = 0; s_ValidTypes[Index] != 0; Index++) {
    if (TypeLong == s_ValidTypes[Index]) return (true);
   }

  return (false);
 }
/*===========================================================================
 *		End of Function IsESMRecordModel()
 *=========================================================================*/


/*===========================================================================
 *
 * Function - TCHAR* RemoveIDQuotes (pBuffer, pID);
 *
 * Removes any quotes from the input ID and copies it into the given buffer
 * which is returned. Ensure that the input buffer is large enough to hold
 * the ID string (MWESM_ID_MAXSIZE * 2 ).
 *
 *=========================================================================*/
TCHAR* RemoveIDQuotes (TCHAR* pBuffer, const TCHAR* pID) {

  if (*pID == '"') { 
    int	Length;

    strnncpy(pBuffer, pID + 1, MWESM_ID_MAXSIZE*2);
    Length = TSTRLEN(pBuffer);
    if (Length > 0) pBuffer[Length - 1] = NULL_CHAR;
    return (pBuffer);
   }

  return ((TCHAR *) pID);
 }
/*===========================================================================
 *		End of Class Function RemoveIDQuotes()
 *=========================================================================*/
