/*===========================================================================
 *
 * File:	EsmClass.H
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	February 3, 2003
 *
 * Description
 *
 *=========================================================================*/
#ifndef __ESMCLASS_H
#define __ESMCLASS_H


/*===========================================================================
 *
 * Begin Required Includes
 *
 *=========================================================================*/
  #include "EsmRecord.h"
  #include "EsmSubName.h"
  #include "EsmSubCLDT.h"
/*===========================================================================
 *		End of Required Includes
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Definitions
 *
 *=========================================================================*/
 	
/*===========================================================================
 *		End of Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Class CEsmClass Definition
 *
 * Description
 *
 *=========================================================================*/
class CEsmClass : public CEsmRecord {
  DECLARE_SUBRECCREATE();

  /*---------- Begin Protected Class Members --------------------*/
protected:
  CEsmSubNameFix*	m_pName;
  CEsmSubCLDT*		m_pData;
  CEsmSubName*		m_pDescription;


  /*---------- Begin Protected Class Methods --------------------*/
protected:


  /*---------- Begin Public Class Methods -----------------------*/
public:

	/* Class Constructors/Destructors */
  CEsmClass();
  //virtual ~CEsmClass() { Destroy(); }
  virtual void Destroy (void);

  	/* Compare two fields of the record */
  virtual int CompareFields (const int FieldID, CEsmRecord* pRecord);

  	/* Return a new record object */
  static CEsmRecord* Create (void);

  	/* Create a new, empty, record */
  virtual void CreateNew (CEsmFile* pFile);

  	/* Get a string representation of a particular field */
  virtual const TCHAR* GetFieldString (const int FieldID);

  	/* Return a text representation of the item type */
  virtual const TCHAR* GetItemType (void) { return _T("Class"); }

  	/* Get class members */
  classdata_t*	GetClassData	(void) { return (m_pData ? m_pData->GetClassData() : NULL); }
  const TCHAR*	GetName		(void) { return (m_pName ? m_pName->GetName() : _T("")); }
  const TCHAR*	GetDescription	(void) { return (m_pDescription ? m_pDescription->GetName() : _T("")); }
  long		GetFlags	(void) { return (m_pData ? GetClassData()->Flags : 0); }
  bool		IsPlayable	(void) { return ((GetFlags() & MWESM_CLASSFLAG_PLAYABLE) != 0 ); }
    
  	/* Used to save the various record elements */
  virtual void OnAddSubRecord (CEsmSubRecord* pSubRecord);

	/* Set class members */
  void SetName        (const TCHAR* pString) { if (m_pName) m_pName->SetName(pString); }
  void SetDescription (const TCHAR* pString) { if (m_pDescription) m_pDescription->SetName(pString); }

 };
/*===========================================================================
 *		End of Class CEsmClass Definition
 *=========================================================================*/


#endif
/*===========================================================================
 *		End of File EsmBodyPart.H
 *=========================================================================*/

