/*===========================================================================
 *
 * File:	EsmStatic.H
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	February 3, 2003
 *
 * Description
 *
 *=========================================================================*/
#ifndef __ESMSTATIC_H
#define __ESMSTATIC_H


/*===========================================================================
 *
 * Begin Required Includes
 *
 *=========================================================================*/
  #include "EsmRecord.h"
  #include "EsmSubName.h"
/*===========================================================================
 *		End of Required Includes
 *=========================================================================*/



/*===========================================================================
 *
 * Begin Class CEsmStatic Definition
 *
 * Description
 *
 *=========================================================================*/
class CEsmStatic : public CEsmRecord {
  DECLARE_SUBRECCREATE();

  /*---------- Begin Protected Class Members --------------------*/
protected:
  CEsmSubNameFix*	m_pModel;	/* Reference to sub-records */
  

  /*---------- Begin Protected Class Methods --------------------*/
protected:


  /*---------- Begin Public Class Methods -----------------------*/
public:

	/* Class Constructors/Destructors */
  CEsmStatic();
  //virtual ~CEsmStatic() { Destroy(); }
  virtual void Destroy (void);

  	/* Compare two fields of the record */
  virtual int CompareFields (const int FieldID, CEsmRecord* pRecord);

  	/* Return a new record object */
  static CEsmRecord* Create (void);

  	/* Create a new, empty, record */
  virtual void CreateNew (CEsmFile* pFile);

  	/* Get a string representation of a particular field */
  virtual const TCHAR* GetFieldString (const int FieldID);

  	/* Return a text representation of the item type */
  virtual const TCHAR* GetItemType (void) { return _T("Static"); }

  	/* Get class members */
  const TCHAR* GetModel (void) { return (m_pModel ? m_pModel->GetName() : _T("")); }

  	/* Used to save the various record elements */
  virtual void OnAddSubRecord (CEsmSubRecord* pSubRecord);

	/* Set class members */
  void SetModel (const TCHAR* pString) { if (m_pModel) m_pModel->SetName(pString); }

 };
/*===========================================================================
 *		End of Class CEsmStatic Definition
 *=========================================================================*/


#endif
/*===========================================================================
 *		End of File EsmSpell.H
 *=========================================================================*/
