/*===========================================================================
 *
 * File:	EsmsubCTDT.H
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	February 3, 2003
 *
 * For the NPDT data in the creature records.
 *
 *=========================================================================*/
#ifndef __ESMSUBCRDT_H
#define __ESMSUBCRDT_H


/*===========================================================================
 *
 * Begin Required Includes
 *
 *=========================================================================*/
  #include "EsmSubBase.h"
/*===========================================================================
 *		End of Required Includes
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Definitions
 *
 *=========================================================================*/

	/* Creature types */
  #define MWESM_CREATYPE_MIN      0
  #define MWESM_CREATYPE_CREATURE 0
  #define MWESM_CREATYPE_DAEDRA   1
  #define MWESM_CREATYPE_UNDEAD   2
  #define MWESM_CREATYPE_HUMANIOD 3
  #define MWESM_CREATYPE_MAX      3

/*===========================================================================
 *		End of Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Type Definitions
 *
 *=========================================================================*/
#pragma pack(push, 1)

  typedef struct {
	long Type;
	long Level;
	long Strength;
	long Intelligence;
	long Willpower;
	long Agility;
	long Speed;
	long Endurance;
	long Personality;
	long Luck;
	long Health;
	long SpellPts;
	long Fatigue;
	long Soul;
	long Combat;
	long Magic;
	long Stealth;
	long AttackMin1;
	long AttackMax1;
	long AttackMin2;
	long AttackMax2;
	long AttackMin3;
	long AttackMax3;
	long Gold;
   } creaturedata_t;

#pragma pack(pop)
/*===========================================================================
 *		End of Type Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Class CEsmSubCRDT Definition
 *
 * Description
 *
 *=========================================================================*/
class CEsmSubCRDT : public CEsmSubRecord {

  /*---------- Begin Protected Class Members --------------------*/
protected:


  /*---------- Begin Protected Class Methods --------------------*/
protected:


  /*---------- Begin Public Class Methods -----------------------*/
public:

	/* Class Constructors/Destructors */
  //CEsmSubCRDT();
  //virtual ~CEsmSubCRDT() { Destroy(); }
  //virtual void Destroy (void);

	/* Create a name object */
  static CEsmSubRecord* Create (void) {
	CEsmSubRecord* pSubRecord;
	CreatePointerL(pSubRecord, CEsmSubCRDT);
	return (pSubRecord);
   }

	/* Create a new sub-record */
  virtual void CreateNew (void) { 
	CEsmSubRecord::CreateNew();
	CreateArrayPointerL(m_pData, byte, sizeof(creaturedata_t)); 
	m_RecordSize = sizeof(creaturedata_t); 
	memset(m_pData, 0, sizeof(creaturedata_t));
   }

	/* Get class methods */
  creaturedata_t* GetCreatureData (void) { return ((creaturedata_t *) m_pData); }


 };
/*===========================================================================
 *		End of Class CEsmSubCRDT Definition
 *=========================================================================*/


#endif
/*===========================================================================
 *		End of File EsmsubaCRDT.H
 *=========================================================================*/
