/*===========================================================================
 *
 * File:	EsmsubFADT.H
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	February 3, 2003
 *
 * Description
 *
 *=========================================================================*/
#ifndef __ESMSUBFADT_H
#define __ESMSUBFADT_H


/*===========================================================================
 *
 * Begin Required Includes
 *
 *=========================================================================*/
  #include "EsmSubBase.h"
/*===========================================================================
 *		End of Required Includes
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Definitions
 *
 *=========================================================================*/

	/* Flags */
  #define MWESM_FACTFLAG_HIDDEN		1

  	/* Default number of ranks */
  #define MWESM_FACTION_NUMRANKS	10

/*===========================================================================
 *		End of Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Type Definitions
 *
 *=========================================================================*/
#pragma pack(push, 1)

	/* Rank structure */
  typedef struct {
  	long Attribute1;
	long Attribute2;
	long Skill1;
	long Skill2;
	long Faction;
   } rankdata_t;

  typedef struct {
  	long		AttributeID1;
	long		AttributeID2;
	rankdata_t	RankData[MWESM_FACTION_NUMRANKS];
	long		SkillID1;
	long		SkillID2;
	long		SkillID3;
	long		SkillID4;
	long		SkillID5;
	long		SkillID6;
	long		Unknown;
	long		Flags;
   } factiondata_t;

#pragma pack(pop)
/*===========================================================================
 *		End of Type Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Class CEsmSubFADT Definition
 *
 * Description
 *
 *=========================================================================*/
class CEsmSubFADT : public CEsmSubRecord {

  /*---------- Begin Protected Class Members --------------------*/
protected:


  /*---------- Begin Protected Class Methods --------------------*/
protected:


  /*---------- Begin Public Class Methods -----------------------*/
public:

	/* Class Constructors/Destructors */
  //CEsmSubFADT();
  //virtual ~CEsmSubFADT() { Destroy(); }
  //virtual void Destroy (void);

	/* Create a name object */
  static CEsmSubRecord* Create (void) {
	CEsmSubRecord* pSubRecord;
	CreatePointerL(pSubRecord, CEsmSubFADT);
	return (pSubRecord);
   }

	/* Create a new sub-record */
  virtual void CreateNew (void) { 
	CEsmSubRecord::CreateNew();
	CreateArrayPointerL(m_pData, byte, sizeof(factiondata_t)); 
	m_RecordSize = sizeof(factiondata_t); 
	memset(m_pData, 0, sizeof(factiondata_t));
	GetFactionData()->AttributeID1 = 0;
	GetFactionData()->AttributeID2 = 1;
	GetFactionData()->SkillID1 = 0;
	GetFactionData()->SkillID2 = 1;
	GetFactionData()->SkillID3 = 2;
	GetFactionData()->SkillID4 = 3;
	GetFactionData()->SkillID5 = 4;
	GetFactionData()->SkillID6 = 5;
	GetFactionData()->Unknown = -1;
   }

	/* Get class methods */
  factiondata_t* GetFactionData (void) { return ((factiondata_t *) m_pData); }


 };
/*===========================================================================
 *		End of Class CEsmSubFADT Definition
 *=========================================================================*/



#endif
/*===========================================================================
 *		End of File EsmSubFADT.H
 *=========================================================================*/
