/*===========================================================================
 *
 * File:	EsmsubIRDT.H
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	February 3, 2003
 *
 * Description
 *
 *=========================================================================*/
#ifndef __ESMSUBIRDT_H
#define __ESMSUBIRDTXH


/*===========================================================================
 *
 * Begin Required Includes
 *
 *=========================================================================*/
  #include "EsmSubBase.h"
/*===========================================================================
 *		End of Required Includes
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Definitions
 *
 *=========================================================================*/

	/* Number of effects per ingrediant */
  #define MWESM_INGRE_NUMEFFECTS 4

/*===========================================================================
 *		End of Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Type Definitions
 *
 *=========================================================================*/
#pragma pack(push, 1)

  typedef struct {
	float  Weight;
	long   Value;
	long   EffectID[MWESM_INGRE_NUMEFFECTS];
	long   SkillID[MWESM_INGRE_NUMEFFECTS];
	long   AttributeID[MWESM_INGRE_NUMEFFECTS];
   } ingredata_t;

#pragma pack(pop)
/*===========================================================================
 *		End of Type Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Class CEsmSubIRDT Definition
 *
 * Description
 *
 *=========================================================================*/
class CEsmSubIRDT : public CEsmSubRecord {

  /*---------- Begin Protected Class Members --------------------*/
protected:


  /*---------- Begin Protected Class Methods --------------------*/
protected:


  /*---------- Begin Public Class Methods -----------------------*/
public:

	/* Class Constructors/Destructors */
  //CEsmSubIRDT();
  //virtual ~CEsmSubIRDT() { Destroy(); }
  //virtual void Destroy (void);

	/* Create a name object */
  static CEsmSubRecord* Create (void) {
	CEsmSubRecord* pSubRecord;
	CreatePointerL(pSubRecord, CEsmSubIRDT);
	return (pSubRecord);
   }

	/* Create a new sub-record */
  virtual void CreateNew (void) { 
	CEsmSubRecord::CreateNew();
	CreateArrayPointerL(m_pData, byte, sizeof(ingredata_t)); 
	m_RecordSize = sizeof(ingredata_t); 
	memset(m_pData, 0, sizeof(ingredata_t));
	GetIngreData()->EffectID[0] = -1;
	GetIngreData()->EffectID[1] = -1;
	GetIngreData()->EffectID[2] = -1;
	GetIngreData()->EffectID[3] = -1;
	GetIngreData()->SkillID[0] = -1;
	GetIngreData()->SkillID[1] = -1;
	GetIngreData()->SkillID[2] = -1;
	GetIngreData()->SkillID[3] = -1;
	GetIngreData()->AttributeID[0] = -1;
	GetIngreData()->AttributeID[1] = -1;
	GetIngreData()->AttributeID[2] = -1;
	GetIngreData()->AttributeID[3] = -1;
   }

	/* Get class methods */
  ingredata_t* GetIngreData (void) { return ((ingredata_t *) m_pData); }

 };
/*===========================================================================
 *		End of Class CEsmSubAADT Definition
 *=========================================================================*/


#endif
/*===========================================================================
 *		End of File EsmsubINDX.H
 *=========================================================================*/
