/*===========================================================================
 *
 * File:	EsmSubInfoDATA.H
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	February 3, 2003
 *
 * Description
 *
 *=========================================================================*/
#ifndef __ESMSUBINFODATA_H
#define __ESMSUBINFODATA_H


/*===========================================================================
 *
 * Begin Required Includes
 *
 *=========================================================================*/
  #include "EsmSubBase.h"
/*===========================================================================
 *		End of Required Includes
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Definitions
 *
 *=========================================================================*/

	/* Gender types */
  #define MWESM_INFOGENDER_NONE		-1
  #define MWESM_INFOGENDER_MALE		0
  #define MWESM_INFOGENDER_FEMALE	1

/*===========================================================================
 *		End of Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Type Definitions
 *
 *=========================================================================*/
#pragma pack(push, 1)

  typedef struct {
	long Unknown1;
	long Disposition;
	char Rank;
	char Gender;
	char PCRank;
	char Unknown2;
  } infodata_t;

#pragma pack(pop)
/*===========================================================================
 *		End of Type Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Class CEsmSubInfoDATA Definition
 *
 * Description
 *
 *=========================================================================*/
class CEsmSubInfoDATA : public CEsmSubRecord {

  /*---------- Begin Protected Class Members --------------------*/
protected:


  /*---------- Begin Protected Class Methods --------------------*/
protected:


  /*---------- Begin Public Class Methods -----------------------*/
public:

	/* Class Constructors/Destructors */
  //CEsmSubInfoDATA();
  //virtual ~CEsmSubInfoDATA() { Destroy(); }
  //virtual void Destroy (void);

	/* Create a name object */
  static CEsmSubRecord* Create (void) {
	CEsmSubRecord* pSubRecord;
	CreatePointerL(pSubRecord, CEsmSubInfoDATA);
	return (pSubRecord);
   }

	/* Create a new sub-record */
  virtual void CreateNew (void) { 
	CEsmSubRecord::CreateNew();
	CreateArrayPointerL(m_pData, byte, sizeof(infodata_t)); 
	m_RecordSize = sizeof(infodata_t); 
	memset(m_pData, 0, sizeof(infodata_t));
	GetInfoData()->Rank    = -1;
	GetInfoData()->PCRank  = -1;
	GetInfoData()->Gender  = (char) MWESM_INFOGENDER_NONE;
   }

	/* Get class methods */
  infodata_t* GetInfoData (void) { return ((infodata_t *) m_pData); }

 };
/*===========================================================================
 *		End of Class CEsmSubAADT CEsmSubInfoDATA
 *=========================================================================*/


#endif
/*===========================================================================
 *		End of File EsmsubDATA.H
 *=========================================================================*/
