/*===========================================================================
 *
 * File:	EsmsubLHDT.H
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	February 3, 2003
 *
 * Description
 *
 *=========================================================================*/
#ifndef __ESMSUBLHDT_H
#define __ESMSUBLHDT_H


/*===========================================================================
 *
 * Begin Required Includes
 *
 *=========================================================================*/
  #include "EsmSubBase.h"
/*===========================================================================
 *		End of Required Includes
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Definitions
 *
 *=========================================================================*/

	/* Light flags */
  #define MWESM_LIGHTFLAG_DYNAMIC	0x0001
  #define MWESM_LIGHTFLAG_CANCARRY	0x0002
  #define MWESM_LIGHTFLAG_NEGATIVE	0x0004
  #define MWESM_LIGHTFLAG_FLICKER	0x0008
  #define MWESM_LIGHTFLAG_ISFIRE	0x0010
  #define MWESM_LIGHTFLAG_DEFAULTOFF	0x0020
  #define MWESM_LIGHTFLAG_FLICKERSLOW	0x0040
  #define MWESM_LIGHTFLAG_PULSE		0x0080
  #define MWESM_LIGHTFLAG_PULSESLOW	0x0100
  #define MWESM_LIGHTFLAG_FLICKERALL	0x01C8

/*===========================================================================
 *		End of Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Type Definitions
 *
 *=========================================================================*/
#pragma pack(push, 1)

  typedef struct {
	float Weight;
	long  Value;
	long  Time;
	long  Radius;
	union {
		struct {
			byte  Red;	
			byte  Green;	
			byte  Blue;	
			byte  Null;	};
		long ColorRef;
	};

	long  Flags; 
   } lightdata_t;

#pragma pack(pop)
/*===========================================================================
 *		End of Type Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Class CEsmSubLHDT Definition
 *
 * Description
 *
 *=========================================================================*/
class CEsmSubLHDT : public CEsmSubRecord {

  /*---------- Begin Protected Class Members --------------------*/
protected:


  /*---------- Begin Protected Class Methods --------------------*/
protected:


  /*---------- Begin Public Class Methods -----------------------*/
public:

	/* Class Constructors/Destructors */
  //CEsmSubLHDT();
  //virtual ~CEsmSubLHDT() { Destroy(); }
  //virtual void Destroy (void);

	/* Create a name object */
  static CEsmSubRecord* Create (void) {
	CEsmSubRecord* pSubRecord;
	CreatePointerL(pSubRecord, CEsmSubLHDT);
	return (pSubRecord);
   }

	/* Create a new sub-record */
  virtual void CreateNew (void) { 
	CEsmSubRecord::CreateNew();
	CreateArrayPointerL(m_pData, byte, sizeof(lightdata_t)); 
	m_RecordSize = sizeof(lightdata_t); 
	memset(m_pData, 0, sizeof(lightdata_t));
	GetLightData()->Red   = 192;
	GetLightData()->Green = 128;
	GetLightData()->Blue  = 64;
   }

	/* Get class methods */
  lightdata_t* GetLightData (void) { return ((lightdata_t *) m_pData); }

 };
/*===========================================================================
 *		End of Class CEsmSubAADT Definition
 *=========================================================================*/


#endif
/*===========================================================================
 *		End of File EsmsubINDX.H
 *=========================================================================*/
