/*===========================================================================
 *
 * File:	EsmsubNPDT.H
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	February 3, 2003
 *
 * For the NPDT data in the NPC records.
 *
 *=========================================================================*/
#ifndef __ESMSUBNPDT_H
#define __ESMSUBNPDT_H


/*===========================================================================
 *
 * Begin Required Includes
 *
 *=========================================================================*/
  #include "EsmSubBase.h"
/*===========================================================================
 *		End of Required Includes
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Definitions
 *
 *=========================================================================*/

	/* NPC flags */
  #define MWESM_NPCFLAG_FEMALE		0x0001
  #define MWESM_NPCFLAG_ESSENTIAL	0x0002
  #define MWESM_NPCFLAG_RESPAWN		0x0004
  #define MWESM_NPCFLAG_NONE		0x0008
  #define MWESM_NPCFLAG_AUTOCALC	0x0010
  #define MWESM_NPCFLAG_DEFAULT		0x0018

  #define MWESM_NPCFLAG_BLOODRED	0x0000
  #define MWESM_NPCFLAG_BLOODSKEL	0x0400
  #define MWESM_NPCFLAG_BLOODMETAL	0x0800
  #define MWESM_NPCFLAG_BLOODMASK	0x0F00

/*===========================================================================
 *		End of Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Type Definitions
 *
 *=========================================================================*/
#pragma pack(push, 1)

  typedef struct {
	short Level;
	char  Strength;
	char  Intelligence;
	char  Willpower;
	char  Agility;
	char  Speed;
	char  Endurance;
	char  Personality;
	char  Luck;
	char  Skills[MWESM_MAX_SKILLS];
	char  Reputation;
	short Health;
	short SpellPts;
	short Fatigue;
	char  Disposition;
	char  FactionID;
	char  Rank;
	char  Unknown1;
	long  Gold;
   } npclongdata_t;

	/* Auto-calc version */
  typedef struct {
   	short Level;
	char  Disposition;
	char  FactionID;
	char  Rank;
	char  Unknown1;
	char  Unknown2;
	char  Unknown3;
	long  Gold;
  } npcshortdata_t;

#pragma pack(pop)
/*===========================================================================
 *		End of Type Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Class CEsmSubNPDTS Definition
 *
 * Description
 *
 *=========================================================================*/
class CEsmSubNPDTS : public CEsmSubRecord {

  /*---------- Begin Protected Class Members --------------------*/
protected:


  /*---------- Begin Protected Class Methods --------------------*/
protected:


  /*---------- Begin Public Class Methods -----------------------*/
public:

	/* Class Constructors/Destructors */
  //CEsmSubNPDT();
  //virtual ~CEsmSubNPDT() { Destroy(); }
  //virtual void Destroy (void);

	/* Create a name object */
  static CEsmSubRecord* Create (void) {
	CEsmSubRecord* pSubRecord;
	CreatePointerL(pSubRecord, CEsmSubNPDTS);
	return (pSubRecord);
   }
	/* Create a new sub-record */
  virtual void CreateNew (void) { 
	CEsmSubRecord::CreateNew();
	CreateArrayPointerL(m_pData, byte, sizeof(npcshortdata_t)); 
	m_RecordSize = sizeof(npcshortdata_t); 
	memset(m_pData, 0, sizeof(npcshortdata_t));
   }

	/* Get class methods */
  npcshortdata_t* GetNPCData (void) { return ((npcshortdata_t *) m_pData); }


 };
/*===========================================================================
 *		End of Class CEsmSubNPDT Definition
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Class CEsmSubNPDTL Definition
 *
 * Description
 *
 *=========================================================================*/
class CEsmSubNPDTL : public CEsmSubRecord {

  /*---------- Begin Protected Class Members --------------------*/
protected:


  /*---------- Begin Protected Class Methods --------------------*/
protected:


  /*---------- Begin Public Class Methods -----------------------*/
public:

	/* Class Constructors/Destructors */
  //CEsmSubNPDTL();
  //virtual ~CEsmSubNPDTL() { Destroy(); }
  //virtual void Destroy (void);

	/* Create a name object */
  static CEsmSubRecord* Create (void) {
	CEsmSubRecord* pSubRecord;
	CreatePointerL(pSubRecord, CEsmSubNPDTL);
	return (pSubRecord);
   }
	/* Create a new sub-record */
  virtual void CreateNew (void) { 
	CEsmSubRecord::CreateNew();
	CreateArrayPointerL(m_pData, byte, sizeof(npclongdata_t)); 
	m_RecordSize = sizeof(npclongdata_t); 
	memset(m_pData, 0, sizeof(npclongdata_t));
   }

	/* Get class methods */
  npclongdata_t* GetNPCData (void) { return ((npclongdata_t *) m_pData); }

 };
/*===========================================================================
 *		End of Class CEsmSubNPDT Definition
 *=========================================================================*/


#endif
/*===========================================================================
 *		End of File EsmsubaCRDT.H
 *=========================================================================*/
