/*===========================================================================
 *
 * File:	Esmsubname.H
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	February 3, 2003
 *
 * Description
 *
 *=========================================================================*/
#ifndef __ESMSUBNAME_H
#define __ESMSUBNAME_H


/*===========================================================================
 *
 * Begin Required Includes
 *
 *=========================================================================*/
  #include "EsmSubBase.h"
  #include "SString.h"
/*===========================================================================
 *		End of Required Includes
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Class CEsmSubName Definition
 *
 * Description
 *
 *=========================================================================*/
class CEsmSubName : public CEsmSubRecord {

  /*---------- Begin Proected Class Members ---------------------*/
protected:
  CSString	m_Name;


  /*---------- Begin Protected Class Methods --------------------*/
protected:

	/* Helper input methods */
  virtual bool ReadData  (CGenFile& File);
  virtual bool WriteData (CGenFile& File) { if (GetRecordSize() <= 0) return (true); return File.Write((const TCHAR *)m_Name, GetRecordSize()); }


  /*---------- Begin Public Class Methods -----------------------*/
public:

	/* Class Constructors/Destructors */
  //CEsmSubName();
  //virtual ~CEsmSubName() { Destroy(); }
  //virtual void Destroy (void);

	/* Copy from another name record */
  virtual void Copy (CEsmSubRecord* pSubRecord);

	/* Create a name object */
  static CEsmSubRecord* Create (void);

  	/* Finds text in the sub-record */
  virtual bool Find (esmfind_t& FindData) { return (m_Name.FindI(FindData.pText) >= 0); }

	/* Get class methods */
  const TCHAR* GetName		(void) const { return (m_Name); }
  virtual long GetRecordSize	(void) const { return (m_Name.GetLength() + 1); }

	/* Set class methods */
  void SetName (const TCHAR* pName) { m_Name = pName; m_RecordSize = m_Name.GetLength(); }

 };
/*===========================================================================
 *		End of Class CEsmSubName Definition
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Type Definitions
 *
 *=========================================================================*/
/*===========================================================================
 *		End of Type Definitions
 *=========================================================================*/


#endif
/*===========================================================================
 *		End of File Esmsubname.H
 *=========================================================================*/
