/*===========================================================================
 *
 * File:	EsmsubRADT.H
 * Author:	Dave Humphrey (uesp@m0use.net)
 * Created On:	February 3, 2003
 *
 * Description
 *
 *=========================================================================*/
#ifndef __ESMSUBRADT_H
#define __ESMSUBRADT_H


/*===========================================================================
 *
 * Begin Required Includes
 *
 *=========================================================================*/
  #include "EsmSubBase.h"
/*===========================================================================
 *		End of Required Includes
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Definitions
 *
 *=========================================================================*/

	/* Number of skill bonuses for each race */
  #define MWESM_RACEDATA_NUMBONUSES 7

	/* Race flags */
  #define MWESM_RACEFLAG_PLAYABLE	1
  #define MWESM_RACEFLAG_BEAST		2

/*===========================================================================
 *		End of Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Type Definitions
 *
 *=========================================================================*/
#pragma pack(push, 1)

  typedef struct {
	long SkillID;
	long Bonus;
   } raceskilldata_t;

  typedef struct {
	raceskilldata_t SkillBonuses[MWESM_RACEDATA_NUMBONUSES];
	long		Strength[2];
	long		Intelligence[2];
	long		Willpower[2];
	long		Agility[2];
	long		Speed[2];
	long		Endurance[2];
	long		Personality[2];
	long		Luck[2];
	float		Height[2];
	float		Weight[2];
	long		Flags;
  } racedata_t;

#pragma pack(pop)
/*===========================================================================
 *		End of Type Definitions
 *=========================================================================*/


/*===========================================================================
 *
 * Begin Class CEsmSubRADT Definition
 *
 * Description
 *
 *=========================================================================*/
class CEsmSubRADT : public CEsmSubRecord {

  /*---------- Begin Protected Class Members --------------------*/
protected:


  /*---------- Begin Protected Class Methods --------------------*/
protected:


  /*---------- Begin Public Class Methods -----------------------*/
public:

	/* Class Constructors/Destructors */
  //CEsmSubRADT();
  //virtual ~CEsmSubRADT() { Destroy(); }
  //virtual void Destroy (void);

	/* Create a name object */
  static CEsmSubRecord* Create (void) {
	CEsmSubRecord* pSubRecord;
	CreatePointerL(pSubRecord, CEsmSubRADT);
	return (pSubRecord);
   }

	/* Create a new sub-record */
  virtual void CreateNew (void) { 
	CEsmSubRecord::CreateNew();
	CreateArrayPointerL(m_pData, byte, sizeof(racedata_t)); 
	m_RecordSize = sizeof(racedata_t); 
	memset(m_pData, 0, sizeof(racedata_t));
	GetRaceData()->SkillBonuses[0].SkillID = 0;
	GetRaceData()->SkillBonuses[1].SkillID = 1;
	GetRaceData()->SkillBonuses[2].SkillID = 2;
	GetRaceData()->SkillBonuses[3].SkillID = 3;
	GetRaceData()->SkillBonuses[4].SkillID = 4;
	GetRaceData()->SkillBonuses[5].SkillID = 5;
	GetRaceData()->SkillBonuses[6].SkillID = 6;
	GetRaceData()->Strength[0] = 30;
	GetRaceData()->Strength[1] = 30;
	GetRaceData()->Intelligence[0] = 30;
	GetRaceData()->Intelligence[1] = 30;
	GetRaceData()->Willpower[0] = 30;
	GetRaceData()->Willpower[1] = 30;
	GetRaceData()->Agility[0] = 30;
	GetRaceData()->Agility[1] = 30;
	GetRaceData()->Speed[0] = 30;
	GetRaceData()->Speed[1] = 30;
	GetRaceData()->Endurance[0] = 30;
	GetRaceData()->Endurance[1] = 30;
	GetRaceData()->Personality[0] = 30;
	GetRaceData()->Personality[1] = 30;
	GetRaceData()->Luck[0] = 30;
	GetRaceData()->Luck[1] = 30;
	GetRaceData()->Height[0] = 1.0f;
	GetRaceData()->Height[1] = 1.0f;
	GetRaceData()->Weight[0] = 1.0f;
	GetRaceData()->Weight[1] = 1.0f;
   }

	/* Get class methods */
  racedata_t* GetRaceData (void) { return ((racedata_t *) m_pData); }

 };
/*===========================================================================
 *		End of Class CEsmSubRADT Definition
 *=========================================================================*/


#endif
/*===========================================================================
 *		End of File EsmsubRIDT.H
 *=========================================================================*/
